// Subwoofer Test Generator - 10 Hz to 90 Hz sine wave in 0.1 Hz or 1.0 Hz increments
// Jed Margolin 2021

// Messages
struct messages
{
    unsigned char pos;     // position
    unsigned char numchars;         // number of characters
    unsigned char msg[];            // message
};

// Declare the messages
const struct messages msg1 = {0x80, 16, "Subwoofer Tester"};
const struct messages msg2 = {0xC4, 7, "40.6 Hz"};
const struct messages msg3 = {0xC9, 6, "Sweep "};
const struct messages msg4 = {0xC9, 6, "0.1 Hz"};
const struct messages msg5 = {0xC9, 6, "1.0 Hz"};
const struct messages msg6 = {0xC9, 6, "oops! "};
const struct messages msg7 = {0xC1, 11, "Version 1.1"};
const struct messages msg8 = {0xC1, 12, "Jed Margolin"};

void domsg(const struct messages *);  // example: domsg(&msg1);

void wait(unsigned int);
void wait4(unsigned int);

void spi_init(void);
void spi_sendword(unsigned int);
void spi_sendbyte(unsigned char);

void lcd_init(void);
void lcd_reset(void);
void wait10ms(void);
void lcd_wr4(unsigned int);
void lcd_wr_instr(unsigned int);
void lcd_wr_data(unsigned int);
void lcd_wr_bcd(unsigned int, unsigned int);
void clear_lcd(unsigned char);

// Globals
int table_index;
unsigned char sweep;

// For reading, debouncing, and processing the switches
struct myswitch
{
    unsigned char debounce;     // debounce byte
    unsigned char state;        // debounced state of the switch
    unsigned char old;          // old state
    unsigned char press;        // switch has been pressed
    unsigned char count;        // how long the press counter has been running
    unsigned char release;      // how long the release counter has been running
    unsigned char countrun;     // is the counter running?
};

// Declare and initialize the switches
struct myswitch switch1 = {0xFF,0x01,0x01,0x00, 0x00, 0x00, 0x00};
struct myswitch switch2 = {0xFF,0x01,0x01,0x00, 0x00, 0x00, 0x00};
struct myswitch switch3 = {0xFF,0x01,0x01,0x00, 0x00, 0x00, 0x00};

void do_switch(unsigned char, unsigned char, struct myswitch *);   // PortIn, Bit, switch structure
//======================================
